#!/usr/bin/perl -w
# -*- perl -*-
use P4CGI ;
use strict ;
#
#################################################################
#  CONFIGURATION INFORMATION 
#  All config info should be in P4CGI.pm
#
#################################################################
#
#  P4 depot browser, top
#
#################################################################



print &P4CGI::start_page("Introduction to P4DB") ;

print &P4CGI::start_table(" class=\"Text\""),
    "<tr><td>";

my $version = &P4CGI::VERSION() ;
my $changelevel = &P4CGI::CHANGELEVEL() ;
$changelevel = "/$changelevel" if defined $changelevel and $changelevel ;
my $required = &P4CGI::REQUIRED_SERVER_VERSION() ;
my $beta = &P4CGI::BETA_RELEASE() ;
my $depot = &P4CGI::CURR_DEPOT_NO() ;
my $path = &P4CGI::cgi()->url('-absolute'=>1, '-full'=>1 ,'-path'=>1) ;
$path =~ s#/[^/]+$##  ;

if($beta ne "NO") {
    $beta = 
	"<p style=\"color: red ; font-size: 120% ; background-color: #ffe0e0; text-align: center\">\n".
	"This version is an untested pre-release and may contain bugs.\n" ;
}
else {
    $beta="" ;
}

while(<DATA>) {
    s/__VERSION__/$version/g ;
    s/__BETAWARNING__/$beta/g ;
    s/__CHANGELEVEL__/$changelevel/g ;
    s/__REQUIRED_SERVER_VERSION__/$required/g ;
    s/__CURR_DEPO_NO__/$depot/g ;
    s/__PATH__/$path/g ;
    print ;
}

print  "</td></tr>", &P4CGI::end_table() ;

print &P4CGI::end_page() ;

#
# That's all folks
#

__END__
<h1 class="Text">Welcome to P4DB version __VERSION____CHANGELEVEL__</h1>
__BETAWARNING__
<h2 class="Text">About P4DB</h2>
<p class="Text">
    P4DB is a web based depot browser for 
    <a class="normal" href="http://www.Perforce.com" title="Link to Perforce web site">
    Perforce p4</a>. The purpose of P4DB is to present data and statistics
    retrieved from a p4 depot. P4DB can not modify data in the depot or retrieve
    any information from files on clients.
    
<h2 class="Text">Quick guide to P4DB</h2>
<p class="Text">
    This is the default start page and when you first open this page there will be two pull-down 
    menus and two buttons at the top of the page.
    <ul class="Text">
    <li>The left menu contains a set of predefined entry points to P4DB. 
    <li>The right menu is for your personal shortcuts (see below) and is empty by default..
    <li>The "Add shortcuts" button let you add your own
        shortcuts that will be available in the shortcuts menu.
        It is similar to the "bookmarks" or "favourites" function in your web browser but you get 
        to set your own names for the  P4DB shortcuts and they do not clobber your bookmarks or 
        favorites menu.<br>
        You can remove shortcuts in the 
        <a class="normal" href="SetPreferences.cgi?DP=__CURR_DEPO_NO__" title="Link to page">Preferences</a>
        page.<br>
        Browser bookmarks/favourites will also work just fine and you can used any or both.. 
    <li>The last button make the current page the "default start page". This is 
        the page that will be displayed when you open "<a class="normal" href="index.cgi?DP=__CURR_DEPO_NO__" 
        title="Go to index.cgi">index.cgi</a>".
    <li>There is also a "log out" button but I am sure you can figure out the meaing of that one without
        much help <tt>;-)</tt>.
    </ul>
<p class="Text">
    The <a class="normal" href="SetPreferences.cgi?DP=__CURR_DEPO_NO__" title="Link to page">Preferences</a>
    page will let you select depot, if there is more than one, and also set up some preferences.
 
<p class="Text">
    <b>Important for people with color vision deficiency:</b> In the <a class="normal" 
    style="text-decoration: underline" href="SetPreferences.cgi?DP=__CURR_DEPO_NO__" title="Link to page">
    Preferences page</a> you can select a style sheet page that I hope works better for you 
    than the standard style sheet page.
    
<p class="Text">
    It you have a fairly recent browser you can let the pointer hoover over a link to get a small 
    tool-tip popup that will give you some more information about the link.<br>
    To find out if your brower supports tool-tips put the pointer over
    <a class="normal" href="intro.cgi?DP=__CURR_DEPO_NO__" 
       title="Congratulations, your browser supports tool-tip help!">this text</a>

<h2 class="Text">Linking to P4DB</h2>
<p class="Text">
    You might want to add a link to P4DB to a web page. P4DB works best if the link point to 
    <tt>index.cgi</tt>. If you have more than one server to select from you also must add parameter
    <tt>DP=</tt><i>n</i> where <i>n</i> is the server code to <tt>index.cgi</tt>.
<p class="Text">
    If the correct server is set the easiest way is to copy this url:<br>
    <a class="normal" href="__PATH__/index.cgi?DP=__CURR_DEPO_NO__">
    __PATH__/index.cgi?DP=__CURR_DEPO_NO__</a>.

<h2 class="Text">P4DB browser requirements</h2>
<p class="Text">
   P4DB use java-script and cookies. P4DB will not be easy to use without java-script. Without
    cookies you will not be able to modify your <a class="normal" href="SetPreferences.cgi?DP=__CURR_DEPO_NO__" 
    title="Link to page"> user preferences</a>, add shortcuts or change default start page.

<h2 class="Text">P4DB Support and Supported Platforms</h2>

<p class="Text">
    There are no supported platforms basically because there is no support.
    P4DB is open source software and I expect the brave p4 administrator that
    installs P4DB to provide support for end users. I will of course answer
    questions if I can and I am more than willing to listen to suggestions or
    constructive criticism but please forward all this through your
    administrator.

<p class="Text">
    P4DB is developed using the Firefox web browser running on Linux.
    It is also tested with a recent version of MS Explorer
    on Windows.
    This version of P4DB use much more cascaded style sheets (CSS) and 
    Java-Script than the earlier versions. This require more from the
    browser and P4DB __VERSION__ will probably not run well on
    Netscape browsers older than 6.2 or Explorer older than version 5.5.

<h2 class="Text">P4DB p4 server requirements</h2>
<p class="Text">
    P4DB __VERSION__ requires p4 server software 
    __REQUIRED_SERVER_VERSION__ or newer. 

<h2 class="Text">Miscellaneous Links</h2>
 
<p class="Text">
    <ul class="Text">
    <li><a class="normal" href="README.html" title="Link to page" target="_blank">Readme file for P4DB administrators</a>
    <li><a class="normal" href="http://www.perforce.com" title="Link to page" target="_blank">Perforce</a>
    <li><a class="normal" href="http://www.fredricson.nu/P4DB" title="Link to page" target="_blank">P4DB project home page</a>
    </ul>
